diff --git a/src/compilation-interface.lisp b/src/compilation-interface.lisp
index e715279..6851eeb 100644
--- a/src/compilation-interface.lisp
+++ b/src/compilation-interface.lisp
@@ -1,6 +1,6 @@
 (in-package "PARENSCRIPT")
 
-(defvar *js-target-version* 1.3)
+(defparameter *js-target-version* 1.3)
 
 (defmacro ps (&body body)
   "Given Parenscript forms (an implicit progn), compiles those forms
diff --git a/src/special-forms.lisp b/src/special-forms.lisp
index e2bda58..dc4b087 100644
--- a/src/special-forms.lisp
+++ b/src/special-forms.lisp
@@ -228,7 +228,7 @@ Syntax of key spec:
 "
   (let* ((var (cond ((symbolp key-spec) key-spec)
                     ((and (listp key-spec) (symbolp (first key-spec))) (first key-spec))
-                    ((and (listp key-spec) (listp (first key-spec)))   (second key-spec))))
+                    ((and (listp key-spec) (listp (first key-spec)))   (second (first key-spec)))))
          (keyword-name (if (and (listp key-spec) (listp (first key-spec)))
                            (first (first key-spec))
                            (intern (string var) :keyword)))
@@ -291,10 +291,10 @@ the given lambda-list and body."
                   (with-ps-gensyms (n)
                     (let ((decls nil) (assigns nil) (defaults nil))
                       (mapc (lambda (k)
-                              (multiple-value-bind (var init-form keyword-str)
+                              (multiple-value-bind (var init-form keyword-name)
                                   (parse-key-spec k)
                                 (push `(var ,var) decls)
-                                (push `(,keyword-str (setf ,var (aref arguments (1+ ,n)))) assigns)
+                                (push `(',keyword-name (setf ,var (aref arguments (1+ ,n)))) assigns)
                                 (push (list 'defaultf var init-form) defaults)))
                             (reverse keys))
                       `(,@decls
@@ -302,13 +302,14 @@ the given lambda-list and body."
                            :below (length arguments) :by 2 :do
                            (case (aref arguments ,n) ,@assigns))
                         ,@defaults)))
-                  (mapcar (lambda (k)
-                            (multiple-value-bind (var init-form keyword-str)
-                                (parse-key-spec k)
-                              (with-ps-gensyms (x)
-                                `(let ((,x ((@ *Array prototype index-of call) arguments ,keyword-str ,(length requireds))))
-                                   (var ,var (if (= -1 ,x) ,init-form (aref arguments (1+ ,x))))))))
-                          keys))))
+		  (progn
+		    (mapcar (lambda (k)
+			      (multiple-value-bind (var init-form keyword-name)
+				  (parse-key-spec k)
+				(with-ps-gensyms (x)
+				  `(let ((,x ((@ *Array prototype index-of call) arguments ',keyword-name ,(length requireds))))
+				     (var ,var (if (= -1 ,x) ,init-form (aref arguments (1+ ,x))))))))
+			    keys)))))
            (rest-form
             (if rest?
                 (with-ps-gensyms (i)
